#!/usr/libexec/platform-python
# -*- coding: utf-8 -*-
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2016 Marek Marczykowski-Górecki
#                                   <marmarek@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
# USA.
#

from smtpd import SMTPServer
import asyncore
import mailbox

class LocalSMTPServer(SMTPServer):
    def process_message(self, peer, mailfrom, rcpttos, data, **kwargs):
        msg = mailbox.Message(data)
        mbox = mailbox.mbox('/var/mail/user')
        mbox.lock()
        mbox.add(msg)
        mbox.close()

if __name__ == '__main__':
    LocalSMTPServer(('localhost', 8025), None)
    try:
        asyncore.loop()
    except KeyboardInterrupt:
        pass
